#region License
/* 
 * All content copyright Marko Lahma, unless otherwise indicated. All rights reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not 
 * use this file except in compliance with the License. You may obtain a copy 
 * of the License at 
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0 
 *   
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT 
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the 
 * License for the specific language governing permissions and limitations 
 * under the License.
 * 
 */
#endregion

using System.Threading.Tasks;

namespace Quartz.Job
{
	/// <summary>
	/// An implementation of Job, that does absolutely nothing - useful for system
	/// which only wish to use <see cref="ITriggerListener" />s
	/// and <see cref="IJobListener" />s, rather than writing
	/// Jobs that perform work.
	/// </summary>
	/// <author>James House</author>
    /// <author>Marko Lahma (.NET)</author>
    public class NoOpJob : IJob
	{
		/// <summary>
		/// Do nothing.
		/// </summary>
		public Task Execute(IJobExecutionContext context)
		{
            return Task.FromResult(true);
        }
	}
}